2011 Feb15: release 0.25.0

- 微分方程式の解を出力するODE述語の追加
- ODE述語で積分を行うintegral述語の追加
- ODE述語で微分を行うODEdiff述語の追加
- ODE述語で出力を行うODEprint, ODEprintf述語の追加
- ODE述語で出力を行うODEprint, ODEprintf述語の追加
- ODE述語でコマンドリストの呼び出しを行うODEcmdの追加
- 微分方程式の例題を追加
- htmlファイルを分割するhtmlsplit述語を追加
- htmlファイルの左部分を取り出すhtmlleft述語を追加
- htmlファイルの右部分を取り出すhtmlright述語を追加
- htmldecode述語で、UTF8の空白をASCIIの空白に変換する機能の追加
- オブジェクトの継承関係の見直し

以下のバグを修正しました。

- カッコの前の負の単項演算子の構文解釈のエラーを修正
- erasetag述語で文字列が小文字に変換されるバグを修正
- オブジェクトに対するgetVarとgetArray述語のスコープのバグを修正
- getVarとgetArrayを予約語に追加
- 不要なstring.hヘッダを削除
- 例題Closure Basicで再帰処理のバグを修正


2011 Sept19: release 0.24.0

- httpクライアントの改善
- httpクライアントの例題としてRSSリーダーを追加
- 文字コードの判定を行うstrcode述語の追加
- iconv述語の文字コードの自動判定機能の追加
- 以下の述語の引数で文字列リストを指定可能とする。
  split, splitline, trim, lefttrim, righttrim, chop, and chomp,
  urlencode, urldecode, htmlencode, htmldecode, concat, concatcode,
  regex, gsub, sub, grep, grepi, grepv, 
- リストを平坦化するflatten述語の追加
- mingwでregexライブラリを利用可能にする。
- 正規表現を使うregex, gsub, sub, grep, grepi, grepv述語を追加する。
- configure, Makefileをlinux, cygwin, mingw, opensolarisで共通化
- permutation, combination述語を改善
- ファイルの内容を変数に読み込むfileget述語を追加
- タグでhtmlを区切ってリスト化するsplittags述語を追加
- ソースで未定義述語やスペルを誤まった述語を検出するCHECKSRC述語を追加
- Windowsでの画面クリア機能の追加


以下のバグを修正しました。

- compare, comparef, comparecの判定ミスを修正
- htmltagsでのSIGSEGV発生を修正

2011 Aug14: release 0.23.0

- httpクライアント機能を追加
  (GETメソッドのhttpget, HEADメソッドのhttphead, POSTメソッドのhttppost)
- 環境変数を取得するgetenv述語を追加
- POSTメソッドでエンコード、デコードするhtmlencode, htmldecode述語を追加
- urlの引数としてエンコード・デコードするurlencode, urldecode述語の追加
- htmlの指定したタグの範囲を抜き出すhtmltags述語を追加
- htmlの指定したタグの範囲を消すerasetags述語を追加
- htmlのタグをすべて消すerasealltags述語を追加
- 指定した範囲の文字列を抜き出すpulloutstr述語を追加
- 指定した範囲の文字列を消すerasestr述語を追加
- httpクライアント機能のプログラム例題を追加
  (全国電力状況、経済指標、ニュースヘッドライン)

- 文字列コードを変換するiconv述語の追加
- ユニフィケーション(単一化)処理の改善による性能向上
- GC(ガベージ・コレクタ)の改善

以下のバグを修正しました。

- compare, comparef, およびcomparec述語の判定誤りを修正
- sort述語の引数の処理誤りを修正

2011 Jun26: release 0.22.0

- プログラム例: 日本語プログラム言語「紫」の追加
- プログラム例: Descartes lispの改善
- プログラム例: Closure Basicの改善
- sysモジュールにreerse, member述語を追加
- linkモジュール・ライブラリの追加
- mkpredlist述語の追加
- timeout述語の引数に複数の述語を指定可能にした
- 結果表示を制御するPrintResultOn, PrintResultOff述語の追加
- デバッグトレース情報の見直し

以下のバグを修正しました。

- Module変数の初期化
- 注釈記号が構文解析で使えなかった
- flush述語で入力のフラッシュをやめた

2011 Jan11 : release 0.21.1

- 例題 Closure Basicのバグ修正

2011 Jan8 : release 0.21.0

- ガーベージコレクションの性能を2倍に改善
- メモリの使用量を1/10に改善
- リスト処理の性能改善
- 高速のappend述語をsysモジュールに追加
- flush述語をsysモジュールに追加
- オブジェクトか判定するcheckObj述語を追加
- 乱数述語randomの改良
- 例題の会話キャラクターの改良
- ソースをOpenSolarisに対応
- 例題としてClosure Basicのコンパイラを追加

以下のバグを修正しました。

- length述語の()の長さ判定を0に修正
- 文字列から数字に変換するときの異常を修正
- openr, openwrのエラーメッセージの修正
- 1文字のトークンの読み込む述語の修正


2010 Aug22: release 0.20.0

- 例題の会話キャラクタ(Eliza、猫耳、ツンデレ)の更新
- 例題のデカルトLispの更新
- 処理を途中で中断するcatch述語とthrow述語の追加
- 複数の値との一致を調べるEqOR述語の追加
- 一致した値と対応する処理に分岐するswitch述語の追加
- リストのn番目を処理するnth述語とsetnth述語の追加
- オブジェクトのトレース情報の追加
- 指定した長さのリストを作成するpadding述語の追加

以下のバグを修正しました。

- ファイル入力時のファイルポインタの処理異常
- オブジェクトのメソッド呼び出しの誤りを修正
- EOF述語の空白処理の方法を変更
- オブジェクトのクローン処理での新旧オブジェクトの分離処理


2010 Apr25: release 0.19.0

- 例題の会話キャラクタ(Eliza、猫耳、ツンデレ)の作成
- catch述語とthrow述語の追加
- スタンドアローン・アプリケーションを作成するための仕組みを追加

以下のバグを修正しました。

- generatorライブラリで引数がNilの場合の対応


2010 Apr11: release 0.18.0

- 例題デカルトLisp/λの大幅な改良。
- Windows向けデカルト言語IDEの追加
- リスト表示の拡張

以下のバグを修正しました。

- ファイルopen述語のエラーを修正
- 改行処理の修正
- UTF-8の文字範囲の修正
- line述語のエラー判定の修正

2010 Feb7: release 0.17.0

- デカルトLisp/λを例題として追加。
- デバッグ用トレース出力をONにする、-tオプション, --traceオプションを追加。
- 実行結果表示を行わない-rオプションを追加。
- オブジェクト名に変数を指定できるようにした。
- sysモジュールにseq述語を追加
- {}ループに、ループ内の結果を収集する変数を指定できるようにした。
- 符号付の整数と浮動小数点数の構文解析述語SNUMとSFNUMを追加。

以下のバグを修正しました。

- cygwin環境でncurses.hがなかった場合の対処
- オブジェクトのメソッドの動的削除ができない。
- string.hヘッダのインクルードの不足
- getline述語の再実行時に引数の変数がクリアされなかった。
- 長いリストの表示でSIGSEGV。
- NULLLINE述語の再実行時にファイルポインタが戻らない。



2010 Jan10: release 0.16.0

- generatorモジュールの追加
- 予約語のチェック機能の追加


2009 Nov01: release 0.15.0

- break述語の追加
- 未定変数に対するdelVar述語の動作の変更
- listモジュールのマニュアルの追加
- パズル例題の追加

以下のバグを修正しました。

- CR述語の再実行処理の修正
- syntax error時に発生するSIGSEGVの修正


2009 Sep21: release 0.14.0

- トレース情報の追加（未定義述語の表示）
- マルチコア機能のプリティプリント機能の追加
- INDENT, NEXTINDENT述語の追加
- 行列matrixモジュールの追加

以下のバグを修正した。

- NILのprint表示
- CR述語のブランクの処理の異常

2009 Aug02: release 0.13.0

- 文字列処理の強化
　- trim, lefttrim, righttrim述語の追加
　- chop, chomp述語の追加
　- マルチバイトの空白の扱いを拡張
　- strreverse述語の追加
　- strrepeat, strshiftleft, strshiftright述語の追加
　- strsort, strsortreverse述語の追加
　- strlen, strbyte述語の追加
　- strfry述語の追加
　- strdelcntl述語の追加
　- NEXTCHAR, NEXTSTR, NEXTSYNTAXの追加
　- NOTNEXTSTR, NOTNEXTSYNTAXの追加
- is, eq, noteq述語を組み込み述語に追加。
- Nilの表示を()から何も表示しないように変更した。
- マルチコア機能のトレース機能

以下のバグを修正した。

- マルチコア実行時の入出力バッファの更新
- マルチコアプロセスでの乱数の初期化
- foreach, firstforeach, eachproc, firsteachprocの引数がNilのときの処理を修正
- split述語のエラー
- gcc 4.3.3のコンパイル時に出ていた警告メッセージの解消
- substr, leftstr, rightstr, charでのマルチバイト文字の処理

2009 Jul07: release 0.12.0

- cygwin版のマルチコア対応
- mingw版のマルチコア対応
  (mingw版ではマルチコアでは動作せず単一コアでシミュレーション)
- firstfor, firstforeach述語の追加
- マルチコア機能での過剰プロセス生成の抑止

以下のバグを修正した。

- ガーベージコレクション中のSIGSEGV
- マルチコア対応のプロセス間通信エラー
- マルチコア対応での、浮動小数点数の通信エラー

2009 Jun21: release 0.11.0

- マルチコア対応機能の追加
- for, foreach述語の拡張
- findlist述語の追加
- NULLLINE述語の追加
- isObj述語の追加
- cloneObj述語の追加
- object用のテストセットの追加
- object処理の内部処理の見直し


以下のバグを修正した。

- 組み込み述語の引数の評価で異常終了
- make用のファイルのパーミッションの見直し
- delArray, delVar述語の引数の処理の異常
- コメントが途中でEOFになったときの処理を修正
- 固有値の計算でSIGSEGVになるのを修正

2009 Aor29: release 0.10.0

- selfオブジェクトを追加した。
- 会話型処理で、cntl-cを押した場合の処理を追加した。
- sysモジュールにsort, sortascend, sortdescend述語を追加した。
- sysモジュールにisRegistered, isUnregistered述語を追加した。

以下のバグを修正した。

- 修正されていなかった組み込みモジュールの引数の評価を拡張した。
- 不要なtmpfileの削除
- matrixモジュールのmul述語の修正
- オブジェクト指向の機構の異常動作を修正した。
- printlist, printlistnlでNilが出力できなかったのを修正した。
- 文字列変換関数の復帰値を修正した。
- getline述語にリダイレクションで入力するときの異常動作を修正。

2009 Apr08: release 0.9.0

- listモジュールの追加
- matrixモジュールの追加
- cursesモジュールの追加
- Tiny Ruby の例題にエラーハンドリング機能を追加
- 会話処理で述語を追加する機能を追加
- 不要なtrace情報を削除して整理
- GCの起動頻度を上げた
- Windows版でのライブラリの読み込み速度を改善した。

以下のバグを修正した。

- 値のない変数のエラーメッセージを改善した。
- is〜述語のエラー判定条件を見直した
- regexのエラーメッセージを見直した。
- instr述語の名前が誤っていたので修正した。
- getc述語でEOFの読み込みで結果判定の誤りを修正
- delArray述語のエラー処理の誤りを修正
- マルチバイト文字の読み込みでSEGVエラーになることを防止
- regexのエラー処理を修正
- ファイル読み込みのバッファオーバーフローを防止
- 構文解析処理の未定義変数を初期化

2009 Mar15: release 0.8.0

- 述語関数の引数の評価範囲の拡大
- trace情報の整理
- LIST操作述語の追加
- list, pwd述語の画面表示機能
- 文字列操作述語leftstr, rightstr, substr, insertの追加
- コンパイラ支援機能の追加
- 特殊述語であるx述語の追加
- curses機能の追加
- 引数が異常な場合のエラーチェック強化
- iconの追加と変更
- 新しいプログラム例の追加とドキュメント作成
- リグレッションテストセットの作成
- 不要な述語の削除と整理
- エラー時のメッセージ表示の強化

-以下のバグを修正
- RANGE述語でSIGSEGV
- ファイルをopenする述語のエラー処理
- car, cdr述語の結果異常
- syntax述語のSIGSEGV
- isPred述語の判定誤り
- 数の比較述語の結果異常
- gsub述語の結果異常


2009 Feb24: release 0.7.0

- 複素数のサポートとletc、rpnc述語の追加
- 三角関数と対数関数の複素数サポート
- 複素数操作のreal, image, arg, norm, conj, polar述語の追加
- 数学定数のPI, e述語の追加
- 合計値を計算するsum, sumf述語の追加
- 平均値を計算するavg, avgf述語の追加
- 浮動小数点数のisNan, inInf, Finite述語の追加
- 2と10の累乗を求めるext2, ext10述語の追加
- パターンマッチでSJISの２バイト目とアスキーコードが重複しても処理できるように修正
- 構文解析のSKIP, SKIPCR述語の追加
- ファイル名のサフィックスを変更するsuffix述語の追加
- リストのｎ番目の要素を取り出すnth述語の追加
- 文字列操作のleftstr, rightstr, substr, insertstr述語の追加


2009 Feb15: release 0.6.0

- オブジェクト指向の継承機構の見直し
- オブジェクト指向のself, super述語の追加
- objDelArray述語の見直し
- printf述語、フォーマット述語とエスケープシーケンス述語の追加
- LIST表示機能のprintlist, printlistnl述語を追加
- システム情報を表示するuname述語の追加
- パスのファイルとディレクトリを取り出すbasename, dirname述語の追加
- 画面をクリアするclear述語の追加
- sleep, usleep述語の追加
- pause述語の追加
- regex, gsub, sub述語のエラー処理の更新
- example例題の追加


2009 Feb8: release 0.5.0

- 動的なオブジェクト操作方法の追加
- コマンドラインオプションで文字コードの種別を選択可
- time述語の表示の変更
- pow述語の追加
- HELPの実装
- インタラクション処理の変更
- オブジェクトの表示の変更
- func関数述語のトレース情報の変更
- save述語の保存方法の変更


2009 Feb1: release 0.4.0

- 浮動小数点の演算精度をdoubleからlong doubleに拡張
- *ワイルドカード述語の修正
- *ワイルドカード述語のトレース情報の追加
- syntax述語の追加
- concat, concatcode述語の追加
- programモジュールの表示方法の変更
- 実行時間を計測するtime述語の追加
- toupper, tolower述語の追加
- floor, log10, max, min, maxf, minf述語の追加
- 会話型処理の改善
- Makefileのコンパイル方法の見直し



2009 Jan25: release 0.3.0

- EBNF構文解析述語をsysモジュールから組み込み述語に変更
- syntax述語の追加
- *ワイルドカード述語の追加
- gettime述語の追加
- date述語の追加
- save述語の追加
- 実行結果のresult表示のプリティプリント化
- ドキュメントの更新。
- ドキュメントの英訳。
- exampleプログラムの更新。
- sysモジュールと組み込み述語のソースを分離



2009 Jan17: release 0.2.0

- 整数の精度を32bitから64bitに拡張した。
- edit述語の追加。
- for述語のループ回数の変更。
- 行のヘッドとマッチする述語を追加：<^>。
- 行の最後とマッチする述語を追加: <$>。
- cd, dir, ls, pwd述語を追加した。
- Windows版でrandom述語のサポートした。
- ドキュメントの更新。
- ドキュメントの英訳。
- exampleプログラムの更新。
- Makefileのコンパイルオプションの変更。
- config.hの追加。


2009 Jan12: new release 0.1.0
